open String;;
#use "input.ml";;

let canalsorti = open_out "Parser.xml";;

(*Ecrire le monde*)

let ecriremonde monde = let (largeur,hauteur) = monde in
output canalsorti "<Monde largeur=\"" 0 16;
output canalsorti (string_of_int largeur) 0 (length (string_of_int largeur));
output canalsorti "\" hauteur=\"" 0 11;
output canalsorti (string_of_int hauteur) 0 (length (string_of_int hauteur));
output canalsorti "\"/>" 0 3;
;;

(*Ecrire un Lemming*)

let ecrirelemming lemming = let (nature,nombre) = lemming in
output canalsorti "<Lemming nature=\"" 0 17;
output canalsorti (nature) 0 (length (nature));
output canalsorti "\" nombre=\"" 0 10;
output canalsorti (string_of_int nombre) 0 (length (string_of_int nombre));
output canalsorti "\"/>" 0 3;
;;

let rec ecrirelistelemming ll = match ll with
|[] -> ()
|[t] -> ecrirelemming t
|t::q -> ecrirelemming t; ecrirelistelemming q;;

(*Ecrire une clé*)

let ecrirecle clef = let (taille,nombre,image) = clef in
output canalsorti "<Cle taille=\"" 0 13;
output canalsorti (string_of_int taille) 0 (length (string_of_int taille));
output canalsorti "\" nombre=\"" 0 10;
output canalsorti (string_of_int nombre) 0 (length (string_of_int nombre));
output canalsorti "\" image=\"" 0 9;
output canalsorti (image) 0 (length (image));
output canalsorti "\"/>" 0 3;
;;


(*Ecrire une pièce*)

let ecrirepiece piece = let (taille,nombre,image) = piece in
output canalsorti "<Piece taille=\"" 0 15;
output canalsorti (string_of_int taille) 0 (length (string_of_int taille));
output canalsorti "\" nombre=\"" 0 10;
output canalsorti (string_of_int nombre) 0 (length (string_of_int nombre));
output canalsorti "\" image=\"" 0 9;
output canalsorti (image) 0 (length (image));
output canalsorti "\"/>" 0 3;
;;

let ecriremap map = let (image,position_exit_x,position_exit_y) = map in
output canalsorti "<Map image=\"" 0 12;
output canalsorti (image) 0 (length (image));
output canalsorti "\" position_exit_x=\"" 0 19;
output canalsorti (string_of_int position_exit_x) 0 (length (string_of_int position_exit_x));
output canalsorti "\" position_exit_y=\"" 0 19;
output canalsorti (string_of_int position_exit_y) 0 (length (string_of_int position_exit_y));
output canalsorti "\"/>" 0 3;
;;

(*Ecrire le mode*)
let ecriremode mode =
let (niveau,lemminglist,map) = mode in
output canalsorti "<Mode niveau =\"" 0 15;
output canalsorti (niveau) 0 (length (niveau));
output canalsorti "\">" 0 2;
ecrirelistelemming lemminglist;
(* ecrirecle cle; *)
(* ecrirepiece piece; *)
ecriremap map;
output canalsorti "</Mode>" 0 7;
;;

(*la liste des modes*)
let rec ecrirelistemode modelist = match modelist with
|[] -> ()
|[t] -> ecriremode t
|t::q -> ecriremode t; ecrirelistemode q;;

let ecriretoutmode mode = 
output canalsorti "<ListeModes>" 0 12;
ecrirelistemode mode;
output canalsorti "</ListeModes>" 0 13;
;;

let ecrirecondition condition =
output canalsorti "<Condition nature =\"" 0 20;
output canalsorti (condition) 0 (length (condition));
output canalsorti "\"/>" 0 3;
;;

let rec ecrirelistecondition cl = match cl with
|[] -> ()
|[t] -> ecrirecondition t
|t::q -> ecrirecondition t; ecrirelistecondition q;;



let ecrireaction action =
output canalsorti "<Action nature =\"" 0 17;
output canalsorti (action) 0 (length (action));
output canalsorti "\"/>" 0 3;
;;

let rec ecrireactionlist al = match al with
|[] -> ()
|[t] -> ecrireaction t
|t::q -> ecrireaction t; ecrireactionlist q;;




let ecrireetat state = let (id,name,image) = state in 
output canalsorti "<etat id =\"" 0 11;
output canalsorti (string_of_int id) 0 (length (string_of_int id));
output canalsorti "\" nom=\"" 0 7;
output canalsorti (name) 0 (length (name));
output canalsorti "\" image=\"" 0 9;
output canalsorti (image) 0 (length (image));
output canalsorti "\"/>" 0 3;;

let rec ecrireetatlist statelist = match statelist with
|[] -> ()
|[t]-> ecrireetat t
|t::q -> ecrireetat t;ecrireetatlist q;;


let ecriretransition transition =
let (etat_i,etat_f,conditions,actions) = transition in
output canalsorti "<Transition>" 0 12;
ecrireetat etat_i;
ecrireetat etat_f;
ecrirelistecondition conditions;
ecrireactionlist actions;
output canalsorti "</Transition>" 0 13;
;;

let rec ecrirelistetransition tl = match tl with
|[] -> ()
|[t] -> ecriretransition t
|t::q -> ecriretransition t; ecrirelistetransition q;;





let ecrireautomate automate =
let (name,etat_i,etat_f,tl) = automate in
output canalsorti "<Automate nom =\"" 0 16;
output canalsorti (name) 0 (length (name));
output canalsorti "\">" 0 2;
ecrireetat etat_i;
ecrireetatlist etat_f;
ecrirelistetransition tl;
output canalsorti "</Automate>" 0 11;
;;


let rec ecrirelisteautomate aul = match aul with
|[] -> ()
|[t] -> ecrireautomate t
|t::q -> ecrireautomate t; ecrirelisteautomate q;;


let ecrirecomportement comportement =
let (nature,automate) = comportement in
output canalsorti "<Comportement nature =\"" 0 23;
output canalsorti (nature) 0 (length (nature));
output canalsorti "\">" 0 2;
ecrireautomate automate;
output canalsorti "</Comportement>" 0 15;
;;

let rec ecrirelistecomportement cl = match cl with
|[] -> ()
|[t] -> ecrirecomportement t
|t::q -> ecrirecomportement t; ecrirelistecomportement q;;

let ecriretoutcomportement cpt = 
output canalsorti "<ListeComportements>" 0 20;
ecrirelistecomportement cpt;
output canalsorti "</ListeComportements>" 0 21;
;;


(**Fonction finale*)

let str = "1.0";;

let ecriretout jeu = let (liste,cl) = jeu in 
output canalsorti "<?xml version =\"" 0 16;
output canalsorti (str) 0 (length (str));
output canalsorti "\"" 0 1;
output canalsorti "?>" 0 2;
output canalsorti "<Jeu>" 0 5;
(*ecriremonde monde;*)
ecriretoutmode liste;
ecriretoutcomportement cl;
output canalsorti "</Jeu>" 0 6
;;


(* appel de la fonction globale *)
ecriretout jeu;;

(* on ferme le fichier a ecrire *)
close_out canalsorti;;

(* ocamlc -o sortie parser.ml
   ./sortie 
   
   ou si fichiers différents :
   ocaml parser.ml *)
